package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntDeserializer;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntSerializer;
// UnionType: AccountType
// UnionValue: LiteTokenAccount

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("LiteTokenAccount")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class LiteTokenAccount implements Account {
	public final AccountType type = AccountType.LITE_TOKEN_ACCOUNT;
	private Url url;
	private Url tokenUrl;
	private java.math.BigInteger balance;
	private long lockHeight;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public LiteTokenAccount url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public LiteTokenAccount url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public Url getTokenUrl() {
	    return tokenUrl;
	}
	public void setTokenUrl(final Url value) {
	    this.tokenUrl = value;
	}

	public LiteTokenAccount tokenUrl(final Url value) {
	    setTokenUrl(value);
	    return this;
	}
	public LiteTokenAccount tokenUrl(final String value) {
	    setTokenUrl(Url.toAccURL(value));
	    return this;
	}
	@JsonDeserialize(using = GoBigIntDeserializer.class)
	public java.math.BigInteger getBalance() {
	    return balance;
	}
	@JsonSerialize(using = GoBigIntSerializer.class)
	public void setBalance(final java.math.BigInteger value) {
	    this.balance = value;
	}

	public LiteTokenAccount balance(final java.math.BigInteger value) {
	    setBalance(value);
	    return this;
	}
	public long getLockHeight() {
	    return lockHeight;
	}
	public void setLockHeight(final long value) {
	    this.lockHeight = value;
	}

	public LiteTokenAccount lockHeight(final long value) {
	    setLockHeight(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.tokenUrl == null)) {
            marshaller.writeUrl(3, this.tokenUrl);
        }
        if (!((this.balance).equals(java.math.BigInteger.ZERO))) {
            marshaller.writeBigInt(4, this.balance);
        }
        if (!(this.lockHeight == 0)) {
            marshaller.writeUint(5, this.lockHeight);
        }
        return marshaller.array();
    }
}
